#!/bin/bash
#
# Helper script for xbmc_myth.py
#
# the following line contains the API key from www.TheTvDb.Com. 
#
APIkey=6DF511BB2A64E0E9
#
# Main
#
me="$1"
shift
#
# tvbd_get
#
if [ "$me" == "tvdb_get" ]; then
  Timeout=50 
  MythSExx=/myth/tmp/tvdbworkingdir
  if [ ! -d "$MythSExx" ]; then 
     mkdir -p $MythSExx
     if [ $? -ne 0 ]; then
         echo "Bad status on attempt to mkdir -p $MythSExx"
         exit 1
     fi
     chmod a+rwx $MythSExx
  fi
  #
  # Set episode name, dir, extension, and showname from the input parameters.
  #
  ShowName="$1"
  outfile="$2"
  #
  #Check for show translations relating to the show in question.
  #
  if [ -f $MythSExx/showtranslations ]; then 
     showtranslation=`grep "$ShowName = " "$MythSExx/showtranslations"|replace "$ShowName = " ""|replace "$MythSExx/showtranslations" ""`   
     if [ "$showtranslation" != "$null" ];then 
        ShowName=$showtranslation
          echo "USER TRANSLATION: $1 = $ShowName">>"$MythSExx"/output.log
          elif [ "$showtranslation" = "$null" ];then
               $showtranslation = "Inactive"
               fi
  fi
  # 
  # SEARCH FOR SHOW NAME
  #
  echo "SEARCHING: www.TheTvDb.com SHOW NAME: $ShowName EPISODE: $epn">>"$MythSExx"/output.log
  echo "FILE NAME: $3">>"$MythSExx"/output.log
  #
  #download series info for show, parse into temporary text db- sid.txt shn.txt
  #
  tvdbshowname=`echo $ShowName|replace " " "%20"`
  curl -s -m"$Timeout" www.thetvdb.com/api/GetSeries.php?seriesname=$tvdbshowname>$MythSExx/working.xml
  cat $MythSExx/working.xml | grep "<seriesid>"|replace "<seriesid>" ""|replace "</seriesid>" "">$MythSExx/sid.txt
  cat $MythSExx/working.xml | grep "<SeriesName>"|replace "<SeriesName>" ""|replace "</SeriesName>" "">$MythSExx/shn.txt
  #
  #Use fuzzy logic to make the best match of the show name
  #
  serieslinenumber=`agrep -Byn "${ShowName:0:29}" $MythSExx/shn.txt 2>/dev/null |sed 's/:.*//'|grep -m1 ^ ` 
  #
  #Get the seriesid based on the showname
  #
  seriesid=`sed -n $serieslinenumber'p' $MythSExx/sid.txt|grep -m1 ^`
  NewShowName=`sed -n $serieslinenumber'p' $MythSExx/shn.txt|grep -m1 ^`
  # echo "showname is $showname"
  # echo "ShowName is $ShowName"
  # echo "tvdbshowname is $tvdbshowname"
  # echo "$seriesid - $1"
  # echo "NewShowName is $NewShowName"
  # echo "serieslinenumber is $serieslinenumber"
  if [ "$seriesid" == "" ]; then
      echo 0
      exit 1
  else
      if [ "$outfile" == "" ]; then
          echo "$seriesid"
      else
          echo "$seriesid" > "$outfile"
      fi
      exit 0
  fi
#
# Cleanup unused links and associated files.
# $1 is the ful path to the file to delete. Will delete both that file and 
# the corresponing ".nfo", if it exists.
#
elif [ "$me" == "cleanup" ]; then 
  f="$1"
  f_nfo="${f%.*}.nfo"
  f_tbn="${f%.*}.tbn"
  dir=$(dirname "$f")
  if [ -L "$f" ]; then 
    rm -f "$f" "$f_nfo" "$f_tbn"
    flist=$(ls "$dir")
    if [ "$flist" == "tvshow.nfo" ] || [ "$flist" == "" ]; then
      rm -f "$dir/tvshow.nfo" "$dir/.tvdb_knows_me.txt" "$dir/.mytitle"
    fi
  fi
  exit 0
#
# Huh?
#
else
  echo "$0: I don't understand $me"
  exit 2
fi
